Index: dll/win32/schannel/schannel_mbedtls.c
===================================================================
--- dll/win32/schannel/schannel_mbedtls.c	(revision 69411)
+++ dll/win32/schannel/schannel_mbedtls.c	(working copy)
@@ -40,5 +40,9 @@
 
-#include <polarssl/ssl.h>
-#include <polarssl/entropy.h>
-#include <polarssl/ctr_drbg.h>
+#include <mbedtls/ssl.h>
+#include <mbedtls/net.h>
+
+#include <mbedtls/entropy.h>
+#include <mbedtls/ctr_drbg.h>
+#include <mbedtls/md_internal.h>
+#include <mbedtls/ssl_internal.h>
 
@@ -66,9 +70,10 @@
 {
-    ssl_context ssl;
-    entropy_context entropy;
-    ctr_drbg_context ctr_drbg;
-    struct schan_transport *transport;
-} POLARSSL_SESSION, *PPOLARSSL_SESSION;
+    mbedtls_ssl_context      ssl;
+    mbedtls_ssl_config       conf;
+    mbedtls_entropy_context  entropy;
+    mbedtls_ctr_drbg_context ctr_drbg;
+    struct schan_transport  *transport;
+} MBEDTLS_SESSION, *PMBEDTLS_SESSION;
 
-/* custom `net_recv` callback adapter, mbedTLS uses it in ssl_read for
+/* custom `net_recv` callback adapter, mbedTLS uses it in mbedtls_ssl_read for
    pulling data from the underlying win32 net stack */
@@ -76,3 +81,3 @@
 {
-    POLARSSL_SESSION *s = session;
+    MBEDTLS_SESSION *s = session;
     size_t requested = buff_len;
@@ -80,3 +85,3 @@
 
-    TRACE("POLARSSL schan_pull_adapter: (%p/%p, %p, %u)\n", s, s->transport, buff, buff_len);
+    TRACE("MBEDTLS schan_pull_adapter: (%p/%p, %p, %u)\n", s, s->transport, buff, buff_len);
 
@@ -84,3 +89,3 @@
 
-    TRACE("POLARSSL schan_pull_adapter: (%p/%p, %p, %u) status: %#x\n", s, s->transport, buff, buff_len, status);
+    TRACE("MBEDTLS schan_pull_adapter: (%p/%p, %p, %u) status: %#x\n", s, s->transport, buff, buff_len, status);
 
@@ -114,3 +119,3 @@
         ERR("Unknown status code from schan_pull: %d\n", status);
-        return POLARSSL_ERR_NET_RECV_FAILED;
+        return MBEDTLS_ERR_NET_RECV_FAILED;
     }
@@ -118,6 +123,6 @@
     /* this should be unreachable */
-    return POLARSSL_ERR_NET_CONNECT_FAILED;
+    return MBEDTLS_ERR_NET_CONNECT_FAILED;
 }
 
-/* custom `net_send` callback adapter, mbedTLS uses it in ssl_write for
+/* custom `net_send` callback adapter, mbedTLS uses it in mbedtls_ssl_write for
    pushing data to the underlying win32 net stack */
@@ -125,6 +130,6 @@
 {
-    POLARSSL_SESSION *s = session;
+    MBEDTLS_SESSION *s = session;
     int status;
 
-    TRACE("POLARSSL schan_push_adapter: (%p/%p, %p, %u)\n", s, s->transport, buff, buff_len);
+    TRACE("MBEDTLS schan_push_adapter: (%p/%p, %p, %u)\n", s, s->transport, buff, buff_len);
 
@@ -132,3 +137,3 @@
 
-    TRACE("POLARSSL schan_push_adapter: (%p/%p, %p, %u) status: %#x\n", s, s->transport, buff, buff_len, status);
+    TRACE("MBEDTLS schan_push_adapter: (%p/%p, %p, %u) status: %#x\n", s, s->transport, buff, buff_len, status);
 
@@ -147,3 +152,3 @@
         ERR("Unknown status code from schan_push: %d\n", status);
-        return POLARSSL_ERR_NET_SEND_FAILED;
+        return MBEDTLS_ERR_NET_SEND_FAILED;
     }
@@ -151,3 +156,3 @@
     /* this should be unreachable */
-    return POLARSSL_ERR_NET_CONNECT_FAILED;
+    return MBEDTLS_ERR_NET_CONNECT_FAILED;
 }
@@ -157,15 +162,15 @@
     /* NOTE: No support for SSL 2.0 */
-    TRACE("POLARSSL schan_imp_enabled_protocols()\n");
+    TRACE("MBEDTLS schan_imp_enabled_protocols()\n");
 
     return 0
-#ifdef POLARSSL_SSL_PROTO_SSL3
+#ifdef MBEDTLS_SSL_PROTO_SSL3
         | SP_PROT_SSL3_CLIENT | SP_PROT_SSL3_SERVER
 #endif
-#ifdef POLARSSL_SSL_PROTO_TLS1
+#ifdef MBEDTLS_SSL_PROTO_TLS1
         | SP_PROT_TLS1_0_CLIENT | SP_PROT_TLS1_0_SERVER
 #endif
-#ifdef POLARSSL_SSL_PROTO_TLS1_1
+#ifdef MBEDTLS_SSL_PROTO_TLS1_1
         | SP_PROT_TLS1_1_CLIENT | SP_PROT_TLS1_1_SERVER
 #endif
-#ifdef POLARSSL_SSL_PROTO_TLS1_2
+#ifdef MBEDTLS_SSL_PROTO_TLS1_2
         | SP_PROT_TLS1_2_CLIENT | SP_PROT_TLS1_2_SERVER
@@ -175,10 +180,12 @@
 
+static void schan_imp_debug(void *ctx, int level, const char *file, int line, const char *str)
+{
+    WARN("MBEDTLS schan_imp_debug: %s:%04d: %s\n", file, line, str);
+}
+
 BOOL schan_imp_create_session(schan_imp_session *session, schan_credentials *cred)
 {
-    POLARSSL_SESSION *s;
-    int ret;
+    MBEDTLS_SESSION *s = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(MBEDTLS_SESSION));
 
-    WARN("POLARSSL schan_imp_create_session: %p %p %p\n", session, *session, cred);
-
-    s = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(POLARSSL_SESSION));
+    WARN("MBEDTLS schan_imp_create_session: %p %p %p\n", session, *session, cred);
 
@@ -190,54 +197,37 @@
 
-    TRACE("POLARSSL init entropy\n");
-    entropy_init(&s->entropy);
+    TRACE("MBEDTLS init entropy\n");
+    mbedtls_entropy_init(&s->entropy);
 
-    TRACE("POLARSSL init random - change static entropy private data\n");
-    ret = ctr_drbg_init(&s->ctr_drbg, entropy_func, &s->entropy, (unsigned char *) "PolarSSL", 8);
+    TRACE("MBEDTLS init random - change static entropy private data\n");
+    mbedtls_ctr_drbg_init(&s->ctr_drbg);
+    mbedtls_ctr_drbg_seed(&s->ctr_drbg, mbedtls_entropy_func, &s->entropy, NULL, 0);
 
-    if (ret != 0)
-    {
-        ERR("ctr_drbg_init failed with -%x\n", -ret);
+    WARN("MBEDTLS init ssl\n");
+    mbedtls_ssl_init(&s->ssl);
 
-        entropy_free(&s->entropy);
+    WARN("MBEDTLS init conf\n");
+    mbedtls_ssl_config_init(&s->conf);
+    mbedtls_ssl_config_defaults(&s->conf, MBEDTLS_SSL_IS_CLIENT,
+                                          MBEDTLS_SSL_TRANSPORT_STREAM, MBEDTLS_SSL_PRESET_DEFAULT);
 
-        /* safely overwrite the freed context with zeroes */
-        HeapFree(GetProcessHeap(), HEAP_ZERO_MEMORY, s);
+    TRACE("MBEDTLS set BIO callbacks\n");
+    mbedtls_ssl_set_bio(&s->ssl, s, schan_push_adapter, schan_pull_adapter, NULL);
 
-        return FALSE;
-    }
+    TRACE("MBEDTLS set endpoint to %s\n", (cred->credential_use & SECPKG_CRED_INBOUND) ? "server" : "client");
+    mbedtls_ssl_conf_endpoint(&s->conf,   (cred->credential_use & SECPKG_CRED_INBOUND) ? MBEDTLS_SSL_IS_SERVER :
+                                                                                         MBEDTLS_SSL_IS_CLIENT);
 
-    WARN("POLARSSL init ssl\n");
-    ret = ssl_init(&s->ssl);
+    TRACE("MBEDTLS set authmode\n");
+    mbedtls_ssl_conf_authmode(&s->conf, MBEDTLS_SSL_VERIFY_NONE);
 
-    if (ret != 0)
-    {
-        ERR("Error SSL initialization -%x.\n", -ret);
+    TRACE("MBEDTLS set rng\n");
+    mbedtls_ssl_conf_rng(&s->conf, mbedtls_ctr_drbg_random, &s->ctr_drbg);
 
-        ctr_drbg_free(&s->ctr_drbg);
-        entropy_free(&s->entropy);
+    TRACE("MBEDTLS set dbg\n");
+    mbedtls_ssl_conf_dbg(&s->conf, schan_imp_debug, stdout);
 
-        /* safely overwrite the freed context with zeroes */
-        HeapFree(GetProcessHeap(), HEAP_ZERO_MEMORY, s);
+    TRACE("MBEDTLS setup\n");
+    mbedtls_ssl_setup(&s->ssl, &s->conf);
 
-        return FALSE;
-    }
-
-    TRACE("POLARSSL set BIO callbacks\n");
-    ssl_set_bio(&s->ssl, schan_pull_adapter, s, schan_push_adapter, s);
-
-    TRACE("POLARSSL set endpoint %d\n", cred->credential_use);
-    ssl_set_endpoint(&s->ssl, (cred->credential_use & SECPKG_CRED_INBOUND) ? SSL_IS_SERVER : SSL_IS_CLIENT);
-
-    TRACE("POLARSSL set authmode\n");
-    ssl_set_authmode(&s->ssl, SSL_VERIFY_NONE);
-
-    TRACE("POLARSSL set rng\n");
-    ssl_set_rng(&s->ssl, ctr_drbg_random, &s->ctr_drbg);
-
-    TRACE("POLARSSL set versions\n");
-    ssl_set_min_version(&s->ssl, SSL_MIN_MAJOR_VERSION, SSL_MIN_MINOR_VERSION);
-    ssl_set_max_version(&s->ssl, SSL_MAX_MAJOR_VERSION, SSL_MAX_MINOR_VERSION);
-
-    TRACE("POLARSSL schan_imp_create_session END!\n");
-
+    TRACE("MBEDTLS schan_imp_create_session END!\n");
     return TRUE;
@@ -247,4 +237,4 @@
 {
-    POLARSSL_SESSION *s = (POLARSSL_SESSION *)session;
-    WARN("POLARSSL schan_imp_dispose_session: %p\n", session);
+    MBEDTLS_SESSION *s = (MBEDTLS_SESSION *)session;
+    WARN("MBEDTLS schan_imp_dispose_session: %p\n", session);
 
@@ -253,5 +243,5 @@
 
-    ssl_free(&s->ssl);
-    ctr_drbg_free(&s->ctr_drbg);
-    entropy_free(&s->entropy);
+    mbedtls_ssl_free(&s->ssl);
+    mbedtls_ctr_drbg_free(&s->ctr_drbg);
+    mbedtls_entropy_free(&s->entropy);
 
@@ -264,5 +254,5 @@
 {
-    POLARSSL_SESSION *s = (POLARSSL_SESSION *)session;
+    MBEDTLS_SESSION *s = (MBEDTLS_SESSION *)session;
 
-    TRACE("POLARSSL schan_imp_set_session_transport: %p %p %d\n", session, t, s->ssl.state);
+    TRACE("MBEDTLS schan_imp_set_session_transport: %p %p\n", session, t);
 
@@ -273,8 +263,11 @@
 {
-    POLARSSL_SESSION *s = (POLARSSL_SESSION *)session;
+    MBEDTLS_SESSION *s = (MBEDTLS_SESSION *)session;
 
-    FIXME("POLARSSL schan_imp_set_session_target: sess: %p hostname: %s state: %d\n", session, target, s->ssl.state);
+    TRACE("MBEDTLS schan_imp_set_session_target: sess: %p hostname: %s\n", session, target);
 
-    /* FIXME: The wine tests do not pass when we set the hostname. */
-    ssl_set_hostname(&s->ssl, target);
+    /* FIXME: WINE tests do not pass when we set the hostname because in the test cases
+     * contacting 'www.winehq.org' the hostname is defined as 'localhost' so the server
+     * sends a non-fatal alert which preemptively forces mbedTLS to close connection. */
+
+    mbedtls_ssl_set_hostname(&s->ssl, target);
 }
@@ -283,7 +276,7 @@
 {
-    POLARSSL_SESSION *s = (POLARSSL_SESSION *)session;
+    MBEDTLS_SESSION *s = (MBEDTLS_SESSION *)session;
 
-    int err = ssl_handshake(&s->ssl);
+    int err = mbedtls_ssl_handshake(&s->ssl);
 
-    TRACE("POLARSSL schan_imp_handshake: %p %d  err: %#x \n", session, s->ssl.state, err);
+    TRACE("MBEDTLS schan_imp_handshake: %p  err: %#x \n", session, err);
 
@@ -294,3 +287,3 @@
     }
-    else if (err == POLARSSL_ERR_SSL_FEATURE_UNAVAILABLE)
+    else if (err == MBEDTLS_ERR_SSL_FEATURE_UNAVAILABLE)
     {
@@ -301,3 +294,3 @@
     {
-        ERR("schan_imp_handshake: Oops! ssl_handshake returned the following error code: -%#x...\n", -err);
+        ERR("schan_imp_handshake: Oops! mbedtls_ssl_handshake returned the following error code: -%#x...\n", -err);
         return SEC_E_INTERNAL_ERROR;
@@ -306,3 +299,4 @@
     WARN("schan_imp_handshake: Handshake completed!\n");
-    WARN("schan_imp_handshake: Protocol is %s, Cipher suite is %s\n", ssl_get_version(&s->ssl), ssl_get_ciphersuite(&s->ssl));
+    WARN("schan_imp_handshake: Protocol is %s, Cipher suite is %s\n", mbedtls_ssl_get_version(&s->ssl),
+                                                                      mbedtls_ssl_get_ciphersuite(&s->ssl));
     return SEC_E_OK;
@@ -310,181 +304,37 @@
 
-static unsigned int schannel_get_cipher_block_size(int ciphersuite_id)
-{
-    const ssl_ciphersuite_t *cipher_suite = ssl_ciphersuite_from_id(ciphersuite_id);
-    const struct
-    {
-        int algo;
-        unsigned int size;
-    }
-    algorithms[] =
-    {
-        {POLARSSL_CIPHER_NONE,                 1},
-        {POLARSSL_CIPHER_NULL,                 1},
-
-    #ifdef POLARSSL_AES_C
-        {POLARSSL_CIPHER_AES_128_ECB,         16},
-        {POLARSSL_CIPHER_AES_192_ECB,         16},
-        {POLARSSL_CIPHER_AES_256_ECB,         16},
-        {POLARSSL_CIPHER_AES_128_CBC,         16},
-        {POLARSSL_CIPHER_AES_192_CBC,         16},
-        {POLARSSL_CIPHER_AES_256_CBC,         16},
-        {POLARSSL_CIPHER_AES_128_CFB128,      16},
-        {POLARSSL_CIPHER_AES_192_CFB128,      16},
-        {POLARSSL_CIPHER_AES_256_CFB128,      16},
-        {POLARSSL_CIPHER_AES_128_CTR,         16},
-        {POLARSSL_CIPHER_AES_192_CTR,         16},
-        {POLARSSL_CIPHER_AES_256_CTR,         16},
-        {POLARSSL_CIPHER_AES_128_GCM,         16},
-        {POLARSSL_CIPHER_AES_192_GCM,         16},
-        {POLARSSL_CIPHER_AES_256_GCM,         16},
-    #endif
-
-    #ifdef POLARSSL_CAMELLIA_C
-        {POLARSSL_CIPHER_CAMELLIA_128_ECB,    16},
-        {POLARSSL_CIPHER_CAMELLIA_192_ECB,    16},
-        {POLARSSL_CIPHER_CAMELLIA_256_ECB,    16},
-        {POLARSSL_CIPHER_CAMELLIA_128_CBC,    16},
-        {POLARSSL_CIPHER_CAMELLIA_192_CBC,    16},
-        {POLARSSL_CIPHER_CAMELLIA_256_CBC,    16},
-        {POLARSSL_CIPHER_CAMELLIA_128_CFB128, 16},
-        {POLARSSL_CIPHER_CAMELLIA_192_CFB128, 16},
-        {POLARSSL_CIPHER_CAMELLIA_256_CFB128, 16},
-        {POLARSSL_CIPHER_CAMELLIA_128_CTR,    16},
-        {POLARSSL_CIPHER_CAMELLIA_192_CTR,    16},
-        {POLARSSL_CIPHER_CAMELLIA_256_CTR,    16},
-        {POLARSSL_CIPHER_CAMELLIA_128_GCM,    16},
-        {POLARSSL_CIPHER_CAMELLIA_192_GCM,    16},
-        {POLARSSL_CIPHER_CAMELLIA_256_GCM,    16},
-    #endif
-
-    #ifdef POLARSSL_DES_C
-        {POLARSSL_CIPHER_DES_ECB,              8},
-        {POLARSSL_CIPHER_DES_CBC,              8},
-        {POLARSSL_CIPHER_DES_EDE_ECB,          8},
-        {POLARSSL_CIPHER_DES_EDE_CBC,          8},
-        {POLARSSL_CIPHER_DES_EDE3_ECB,         8},
-        {POLARSSL_CIPHER_DES_EDE3_CBC,         8},
-    #endif
-
-    #ifdef POLARSSL_BLOWFISH_C
-        {POLARSSL_CIPHER_BLOWFISH_ECB,         8},
-        {POLARSSL_CIPHER_BLOWFISH_CBC,         8},
-        {POLARSSL_CIPHER_BLOWFISH_CFB64,       8},
-        {POLARSSL_CIPHER_BLOWFISH_CTR,         8},
-    #endif
-
-    #ifdef POLARSSL_ARC4_C
-        {POLARSSL_CIPHER_ARC4_128,             1},
-    #endif
-
-    #ifdef POLARSSL_CCM_C
-        {POLARSSL_CIPHER_AES_128_CCM,         16},
-        {POLARSSL_CIPHER_AES_192_CCM,         16},
-        {POLARSSL_CIPHER_AES_256_CCM,         16},
-        {POLARSSL_CIPHER_CAMELLIA_128_CCM,    16},
-        {POLARSSL_CIPHER_CAMELLIA_192_CCM,    16},
-        {POLARSSL_CIPHER_CAMELLIA_256_CCM,    16},
-    #endif
-    };
-
-    int i;
-    for (i = 0; i < _countof(algorithms); i++)
-    {
-        if (algorithms[i].algo == cipher_suite->cipher)
-            return algorithms[i].size;
-    }
-
-    TRACE("POLARSSL schannel_get_cipher_block_size: Unknown cipher %#x, returning 1\n", ciphersuite_id);
-
-    return 1;
-}
-
 static unsigned int schannel_get_cipher_key_size(int ciphersuite_id)
 {
-    const ssl_ciphersuite_t *cipher_suite = ssl_ciphersuite_from_id(ciphersuite_id);
-    const struct
-    {
-        int algo;
-        unsigned int size;
-    }
-    algorithms[] =
-    {
-        {POLARSSL_CIPHER_NONE,                  0},
-        {POLARSSL_CIPHER_NULL,                  0},
+    const mbedtls_ssl_ciphersuite_t *ssl_cipher_suite = mbedtls_ssl_ciphersuite_from_id(ciphersuite_id);
+    const mbedtls_cipher_info_t          *cipher_info = mbedtls_cipher_info_from_type(ssl_cipher_suite->cipher);
 
-    #ifdef POLARSSL_AES_C
-        {POLARSSL_CIPHER_AES_128_ECB,         128},
-        {POLARSSL_CIPHER_AES_192_ECB,         192},
-        {POLARSSL_CIPHER_AES_256_ECB,         256},
-        {POLARSSL_CIPHER_AES_128_CBC,         128},
-        {POLARSSL_CIPHER_AES_192_CBC,         192},
-        {POLARSSL_CIPHER_AES_256_CBC,         256},
-        {POLARSSL_CIPHER_AES_128_CFB128,      128},
-        {POLARSSL_CIPHER_AES_192_CFB128,      192},
-        {POLARSSL_CIPHER_AES_256_CFB128,      256},
-        {POLARSSL_CIPHER_AES_128_CTR,         128},
-        {POLARSSL_CIPHER_AES_192_CTR,         192},
-        {POLARSSL_CIPHER_AES_256_CTR,         256},
-        {POLARSSL_CIPHER_AES_128_GCM,         128},
-        {POLARSSL_CIPHER_AES_192_GCM,         192},
-        {POLARSSL_CIPHER_AES_256_GCM,         256},
-    #endif
+    unsigned int key_bitlen = cipher_info->key_bitlen;
 
-    #ifdef POLARSSL_CAMELLIA_C
-        {POLARSSL_CIPHER_CAMELLIA_128_ECB,    128},
-        {POLARSSL_CIPHER_CAMELLIA_192_ECB,    192},
-        {POLARSSL_CIPHER_CAMELLIA_256_ECB,    256},
-        {POLARSSL_CIPHER_CAMELLIA_128_CBC,    128},
-        {POLARSSL_CIPHER_CAMELLIA_192_CBC,    192},
-        {POLARSSL_CIPHER_CAMELLIA_256_CBC,    256},
-        {POLARSSL_CIPHER_CAMELLIA_128_CFB128, 128},
-        {POLARSSL_CIPHER_CAMELLIA_192_CFB128, 192},
-        {POLARSSL_CIPHER_CAMELLIA_256_CFB128, 256},
-        {POLARSSL_CIPHER_CAMELLIA_128_CTR,    128},
-        {POLARSSL_CIPHER_CAMELLIA_192_CTR,    192},
-        {POLARSSL_CIPHER_CAMELLIA_256_CTR,    256},
-        {POLARSSL_CIPHER_CAMELLIA_128_GCM,    128},
-        {POLARSSL_CIPHER_CAMELLIA_192_GCM,    192},
-        {POLARSSL_CIPHER_CAMELLIA_256_GCM,    256},
-    #endif
+    TRACE("MBEDTLS schannel_get_cipher_key_size: Unknown cipher %#x, returning %u\n", ciphersuite_id, key_bitlen);
 
-    #ifdef POLARSSL_DES_C
-        {POLARSSL_CIPHER_DES_ECB,              56},
-        {POLARSSL_CIPHER_DES_CBC,              56},
-        {POLARSSL_CIPHER_DES_EDE_ECB,         128},
-        {POLARSSL_CIPHER_DES_EDE_CBC,         128},
-        {POLARSSL_CIPHER_DES_EDE3_ECB,        192},
-        {POLARSSL_CIPHER_DES_EDE3_CBC,        192},
-    #endif
+    return key_bitlen;
+}
 
-    #ifdef POLARSSL_BLOWFISH_C                      /* lies! actually unlimited,    */
-        {POLARSSL_CIPHER_BLOWFISH_ECB,        128}, /* gnutls uses this same value. */
-        {POLARSSL_CIPHER_BLOWFISH_CBC,        128}, /* BLOWFISH_MAX_KEY = 448 bits  */
-        {POLARSSL_CIPHER_BLOWFISH_CFB64,      128}, /* BLOWFISH_MIN_KEY = 032 bits  */
-        {POLARSSL_CIPHER_BLOWFISH_CTR,        128}, /* see blowfish.h for more info */
-    #endif
+static unsigned int schannel_get_mac_key_size(int ciphersuite_id)
+{
+    const mbedtls_ssl_ciphersuite_t *ssl_cipher_suite = mbedtls_ssl_ciphersuite_from_id(ciphersuite_id);
+    const mbedtls_md_info_t                  *md_info = mbedtls_md_info_from_type(ssl_cipher_suite->mac);
 
-    #ifdef POLARSSL_ARC4_C
-        {POLARSSL_CIPHER_ARC4_128,            128},
-    #endif
+    int md_size = md_info->size * CHAR_BIT; /* return the size in bits, as the secur32:schannel winetest shows */
 
-    #ifdef POLARSSL_CCM_C
-        {POLARSSL_CIPHER_AES_128_CCM,         128},
-        {POLARSSL_CIPHER_AES_192_CCM,         192},
-        {POLARSSL_CIPHER_AES_256_CCM,         256},
-        {POLARSSL_CIPHER_CAMELLIA_128_CCM,    128},
-        {POLARSSL_CIPHER_CAMELLIA_192_CCM,    192},
-        {POLARSSL_CIPHER_CAMELLIA_256_CCM,    256},
-    #endif
-    };
+    TRACE("MBEDTLS schannel_get_mac_key_size: returning %i\n", md_size);
 
-    int i;
+    return md_size;
+}
 
-    for (i = 0; i < _countof(algorithms); i++)
-    {
-        if (algorithms[i].algo == cipher_suite->cipher)
-            return algorithms[i].size;
-    }
+static unsigned int schannel_get_kx_key_size(const mbedtls_ssl_context *ssl, const mbedtls_ssl_config *conf, int ciphersuite_id)
+{
+    const mbedtls_ssl_ciphersuite_t *ssl_ciphersuite = mbedtls_ssl_ciphersuite_from_id(ciphersuite_id);
 
-    TRACE("POLARSSL schannel_get_cipher_key_size: Unknown cipher %#x, returning 0\n", ciphersuite_id);
+    /* if we are the server take ca_chain, if we are the client take the proper x509 peer certificate */
+    const mbedtls_x509_crt *server_cert = (conf->endpoint == MBEDTLS_SSL_IS_SERVER) ? conf->ca_chain : mbedtls_ssl_get_peer_cert(ssl);
+
+    if (ssl_ciphersuite->key_exchange != MBEDTLS_KEY_EXCHANGE_NONE)
+        return mbedtls_pk_get_len(&(server_cert->pk));
+
+    TRACE("MBEDTLS schannel_get_kx_key_size: Unknown kx %#x, returning 0\n", ssl_ciphersuite->key_exchange);
 
@@ -493,45 +343,3 @@
 
-static unsigned int schannel_get_mac_key_size(int ciphersuite_id)
-{
-    const ssl_ciphersuite_t *cipher_suite = ssl_ciphersuite_from_id(ciphersuite_id);
-    const unsigned int algorithms[] =
-    {
-          0, /* POLARSSL_MD_NONE      */
-          0, /* POLARSSL_MD_MD2 (not used as MAC) */
-        128, /* POLARSSL_MD_MD4       */
-        128, /* POLARSSL_MD_MD5       */
-        160, /* POLARSSL_MD_SHA1      */
-        224, /* POLARSSL_MD_SHA224    */
-        256, /* POLARSSL_MD_SHA256    */
-        384, /* POLARSSL_MD_SHA384    */
-        512, /* POLARSSL_MD_SHA512    */
-        160  /* POLARSSL_MD_RIPEMD160 */
-    };
-
-    if (cipher_suite->mac >= 0 && cipher_suite->mac < _countof(algorithms))
-    {
-        return algorithms[cipher_suite->mac];
-    }
-
-    TRACE("POLARSSL schannel_get_mac_key_size: Unknown mac %#x for ciphersuite %#x, returning 0\n", cipher_suite->mac, ciphersuite_id);
-
-    return 0;
-}
-
-static unsigned int schannel_get_kx_key_size(const ssl_context *ssl, int ciphersuite_id)
-{
-    const ssl_ciphersuite_t *cipher_suite = ssl_ciphersuite_from_id(ciphersuite_id);
-
-    /* if we are the server take ca_chain, if we are the client take server cert (peer_cert) */
-    x509_crt *server_cert = (ssl->endpoint == SSL_IS_SERVER) ? ssl->ca_chain : ssl->session->peer_cert;
-
-    if (cipher_suite->key_exchange != POLARSSL_KEY_EXCHANGE_NONE)
-        return server_cert->pk.pk_info->get_size(server_cert->pk.pk_ctx);
-
-    TRACE("POLARSSL schannel_get_kx_key_size: Unknown kx %#x, returning 0\n", cipher_suite->key_exchange);
-
-    return 0;
-}
-
-static DWORD schannel_get_protocol(const ssl_context *ssl)
+static DWORD schannel_get_protocol(const mbedtls_ssl_context *ssl, const mbedtls_ssl_config *conf)
 {
@@ -543,17 +351,17 @@
     {
-        case SSL_MINOR_VERSION_0:
-            return (ssl->endpoint == SSL_IS_CLIENT) ? SP_PROT_SSL3_CLIENT :
-                                                      SP_PROT_SSL3_SERVER;
+        case MBEDTLS_SSL_MINOR_VERSION_0:
+            return (conf->endpoint == MBEDTLS_SSL_IS_CLIENT) ? SP_PROT_SSL3_CLIENT :
+                                                               SP_PROT_SSL3_SERVER;
 
-        case SSL_MINOR_VERSION_1:
-            return (ssl->endpoint == SSL_IS_CLIENT) ? SP_PROT_TLS1_0_CLIENT :
-                                                      SP_PROT_TLS1_0_SERVER;
+        case MBEDTLS_SSL_MINOR_VERSION_1:
+            return (conf->endpoint == MBEDTLS_SSL_IS_CLIENT) ? SP_PROT_TLS1_0_CLIENT :
+                                                               SP_PROT_TLS1_0_SERVER;
 
-        case SSL_MINOR_VERSION_2:
-            return (ssl->endpoint == SSL_IS_CLIENT) ? SP_PROT_TLS1_1_CLIENT :
-                                                      SP_PROT_TLS1_1_SERVER;
+        case MBEDTLS_SSL_MINOR_VERSION_2:
+            return (conf->endpoint == MBEDTLS_SSL_IS_CLIENT) ? SP_PROT_TLS1_1_CLIENT :
+                                                               SP_PROT_TLS1_1_SERVER;
 
-        case SSL_MINOR_VERSION_3:
-            return (ssl->endpoint == SSL_IS_CLIENT) ? SP_PROT_TLS1_2_CLIENT :
-                                                      SP_PROT_TLS1_2_SERVER;
+        case MBEDTLS_SSL_MINOR_VERSION_3:
+            return (conf->endpoint == MBEDTLS_SSL_IS_CLIENT) ? SP_PROT_TLS1_2_CLIENT :
+                                                               SP_PROT_TLS1_2_SERVER;
 
@@ -561,3 +369,3 @@
         {
-            FIXME("POLARSSL schannel_get_protocol: unknown protocol %d\n", ssl->minor_ver);
+            FIXME("MBEDTLS schannel_get_protocol: unknown protocol %d\n", ssl->minor_ver);
             return 0;
@@ -569,3 +377,3 @@
 {
-    const ssl_ciphersuite_t *cipher_suite = ssl_ciphersuite_from_id(ciphersuite_id);
+    const mbedtls_ssl_ciphersuite_t *cipher_suite = mbedtls_ssl_ciphersuite_from_id(ciphersuite_id);
 
@@ -573,9 +381,9 @@
     {
-        case POLARSSL_CIPHER_NONE:
-        case POLARSSL_CIPHER_NULL:
+        case MBEDTLS_CIPHER_NONE:
+        case MBEDTLS_CIPHER_NULL:
             return 0;
 
-#ifdef POLARSSL_ARC4_C
+#ifdef MBEDTLS_ARC4_C
         /* ARC4 */
-        case POLARSSL_CIPHER_ARC4_128:
+        case MBEDTLS_CIPHER_ARC4_128:
             return CALG_RC4;
@@ -583,13 +391,12 @@
 
-
-#ifdef POLARSSL_DES_C
+#ifdef MBEDTLS_DES_C
         /* DES */
-        case POLARSSL_CIPHER_DES_ECB:
-        case POLARSSL_CIPHER_DES_CBC:
-        case POLARSSL_CIPHER_DES_EDE_ECB:
-        case POLARSSL_CIPHER_DES_EDE_CBC:
+        case MBEDTLS_CIPHER_DES_ECB:
+        case MBEDTLS_CIPHER_DES_CBC:
+        case MBEDTLS_CIPHER_DES_EDE_ECB:
+        case MBEDTLS_CIPHER_DES_EDE_CBC:
             return CALG_DES;
 
-        case POLARSSL_CIPHER_DES_EDE3_ECB:
-        case POLARSSL_CIPHER_DES_EDE3_CBC:
+        case MBEDTLS_CIPHER_DES_EDE3_ECB:
+        case MBEDTLS_CIPHER_DES_EDE3_CBC:
             return CALG_3DES;
@@ -597,11 +404,42 @@
 
-#ifdef POLARSSL_AES_C
+#ifdef MBEDTLS_BLOWFISH_C
+        /* BLOWFISH */
+        case MBEDTLS_CIPHER_BLOWFISH_ECB:
+        case MBEDTLS_CIPHER_BLOWFISH_CBC:
+        case MBEDTLS_CIPHER_BLOWFISH_CFB64:
+        case MBEDTLS_CIPHER_BLOWFISH_CTR:
+            return CALG_RC4;  // (as schannel does not support it fake it as RC4, which has a
+                              //  similar profile of low footprint and medium-high security) CALG_BLOWFISH;
+#endif
+
+#ifdef MBEDTLS_CAMELLIA_C
+        /* CAMELLIA */
+        case MBEDTLS_CIPHER_CAMELLIA_128_ECB:
+        case MBEDTLS_CIPHER_CAMELLIA_192_ECB:
+        case MBEDTLS_CIPHER_CAMELLIA_256_ECB:
+        case MBEDTLS_CIPHER_CAMELLIA_128_CBC:
+        case MBEDTLS_CIPHER_CAMELLIA_192_CBC:
+        case MBEDTLS_CIPHER_CAMELLIA_256_CBC:
+        case MBEDTLS_CIPHER_CAMELLIA_128_CFB128:
+        case MBEDTLS_CIPHER_CAMELLIA_192_CFB128:
+        case MBEDTLS_CIPHER_CAMELLIA_256_CFB128:
+        case MBEDTLS_CIPHER_CAMELLIA_128_CTR:
+        case MBEDTLS_CIPHER_CAMELLIA_192_CTR:
+        case MBEDTLS_CIPHER_CAMELLIA_256_CTR:
+        case MBEDTLS_CIPHER_CAMELLIA_128_GCM:
+        case MBEDTLS_CIPHER_CAMELLIA_192_GCM:
+        case MBEDTLS_CIPHER_CAMELLIA_256_GCM:
+            return CALG_AES_256;  // (as schannel does not support it fake it as AES, which has a
+                                  //  similar profile, offering modern high security) CALG_CAMELLIA;
+#endif
+
+#ifdef MBEDTLS_AES_C
         /* AES 128 */
-        case POLARSSL_CIPHER_AES_128_ECB:
-        case POLARSSL_CIPHER_AES_128_CBC:
-        case POLARSSL_CIPHER_AES_128_CFB128:
-        case POLARSSL_CIPHER_AES_128_CTR:
-        case POLARSSL_CIPHER_AES_128_GCM:
-    #ifdef POLARSSL_CCM_C
-        case POLARSSL_CIPHER_AES_128_CCM:
+        case MBEDTLS_CIPHER_AES_128_ECB:
+        case MBEDTLS_CIPHER_AES_128_CBC:
+        case MBEDTLS_CIPHER_AES_128_CFB128:
+        case MBEDTLS_CIPHER_AES_128_CTR:
+        case MBEDTLS_CIPHER_AES_128_GCM:
+    #ifdef MBEDTLS_CCM_C
+        case MBEDTLS_CIPHER_AES_128_CCM:
     #endif
@@ -609,9 +447,9 @@
 
-        case POLARSSL_CIPHER_AES_192_ECB:
-        case POLARSSL_CIPHER_AES_192_CBC:
-        case POLARSSL_CIPHER_AES_192_CFB128:
-        case POLARSSL_CIPHER_AES_192_CTR:
-        case POLARSSL_CIPHER_AES_192_GCM:
-    #ifdef POLARSSL_CCM_C
-        case POLARSSL_CIPHER_AES_192_CCM:
+        case MBEDTLS_CIPHER_AES_192_ECB:
+        case MBEDTLS_CIPHER_AES_192_CBC:
+        case MBEDTLS_CIPHER_AES_192_CFB128:
+        case MBEDTLS_CIPHER_AES_192_CTR:
+        case MBEDTLS_CIPHER_AES_192_GCM:
+    #ifdef MBEDTLS_CCM_C
+        case MBEDTLS_CIPHER_AES_192_CCM:
     #endif
@@ -619,9 +457,9 @@
 
-        case POLARSSL_CIPHER_AES_256_ECB:
-        case POLARSSL_CIPHER_AES_256_CBC:
-        case POLARSSL_CIPHER_AES_256_CFB128:
-        case POLARSSL_CIPHER_AES_256_CTR:
-        case POLARSSL_CIPHER_AES_256_GCM:
-    #ifdef POLARSSL_CCM_C
-        case POLARSSL_CIPHER_AES_256_CCM:
+        case MBEDTLS_CIPHER_AES_256_ECB:
+        case MBEDTLS_CIPHER_AES_256_CBC:
+        case MBEDTLS_CIPHER_AES_256_CFB128:
+        case MBEDTLS_CIPHER_AES_256_CTR:
+        case MBEDTLS_CIPHER_AES_256_GCM:
+    #ifdef MBEDTLS_CCM_C
+        case MBEDTLS_CIPHER_AES_256_CCM:
     #endif
@@ -633,3 +471,3 @@
         {
-            FIXME("POLARSSL schannel_get_cipher_algid: unknown algorithm %d\n", ciphersuite_id);
+            FIXME("MBEDTLS schannel_get_cipher_algid: unknown algorithm %d\n", ciphersuite_id);
             return 0;
@@ -641,3 +479,3 @@
 {
-    const ssl_ciphersuite_t *cipher_suite = ssl_ciphersuite_from_id(ciphersuite_id);
+    const mbedtls_ssl_ciphersuite_t *cipher_suite = mbedtls_ssl_ciphersuite_from_id(ciphersuite_id);
 
@@ -645,12 +483,12 @@
     {
-        case POLARSSL_MD_NONE:      return 0;
-        case POLARSSL_MD_MD2:       return CALG_MD2;
-        case POLARSSL_MD_MD4:       return CALG_MD4;
-        case POLARSSL_MD_MD5:       return CALG_MD5;
-        case POLARSSL_MD_SHA1:      return CALG_SHA1;
-        case POLARSSL_MD_SHA224:    return CALG_SHA;
-        case POLARSSL_MD_SHA256:    return CALG_SHA_256;
-        case POLARSSL_MD_SHA384:    return CALG_SHA_384;
-        case POLARSSL_MD_SHA512:    return CALG_SHA_512;
-        case POLARSSL_MD_RIPEMD160: return (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_RIPEMD160); /* there's no CALG_RIPEMD or CALG_RIPEMD160 defined in <wincrypt.h> yet */
+        case MBEDTLS_MD_NONE:      return 0;
+        case MBEDTLS_MD_MD2:       return CALG_MD2;
+        case MBEDTLS_MD_MD4:       return CALG_MD4;
+        case MBEDTLS_MD_MD5:       return CALG_MD5;
+        case MBEDTLS_MD_SHA1:      return CALG_SHA1;
+        case MBEDTLS_MD_SHA224:    return CALG_SHA;
+        case MBEDTLS_MD_SHA256:    return CALG_SHA_256;
+        case MBEDTLS_MD_SHA384:    return CALG_SHA_384;
+        case MBEDTLS_MD_SHA512:    return CALG_SHA_512;
+        case MBEDTLS_MD_RIPEMD160: return (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_RIPEMD160); /* there's no CALG_RIPEMD or CALG_RIPEMD160 defined in <wincrypt.h> yet */
 
@@ -658,3 +496,3 @@
         {
-            FIXME("POLARSSL schannel_get_mac_algid: unknown algorithm %d\n", cipher_suite->mac);
+            FIXME("MBEDTLS schannel_get_mac_algid: unknown algorithm %d\n", cipher_suite->mac);
             return 0;
@@ -666,3 +504,3 @@
 {
-    const ssl_ciphersuite_t *cipher_suite = ssl_ciphersuite_from_id(ciphersuite_id);
+    const mbedtls_ssl_ciphersuite_t *cipher_suite = mbedtls_ssl_ciphersuite_from_id(ciphersuite_id);
 
@@ -670,17 +508,17 @@
     {
-        case POLARSSL_KEY_EXCHANGE_NONE:
+        case MBEDTLS_KEY_EXCHANGE_NONE:
             return 0;
 
-        case POLARSSL_KEY_EXCHANGE_ECDH_RSA:
-        case POLARSSL_KEY_EXCHANGE_ECDH_ECDSA:
-        case POLARSSL_KEY_EXCHANGE_ECDHE_PSK:
-        case POLARSSL_KEY_EXCHANGE_ECDHE_RSA:
+        case MBEDTLS_KEY_EXCHANGE_ECDH_RSA:
+        case MBEDTLS_KEY_EXCHANGE_ECDH_ECDSA:
+        case MBEDTLS_KEY_EXCHANGE_ECDHE_PSK:
+        case MBEDTLS_KEY_EXCHANGE_ECDHE_RSA:
             return CALG_ECDH;
 
-        case POLARSSL_KEY_EXCHANGE_RSA_PSK:
-        case POLARSSL_KEY_EXCHANGE_RSA:
+        case MBEDTLS_KEY_EXCHANGE_RSA_PSK:
+        case MBEDTLS_KEY_EXCHANGE_RSA:
             return CALG_RSA_KEYX;
 
-        case POLARSSL_KEY_EXCHANGE_DHE_PSK:
-        case POLARSSL_KEY_EXCHANGE_DHE_RSA:
+        case MBEDTLS_KEY_EXCHANGE_DHE_PSK:
+        case MBEDTLS_KEY_EXCHANGE_DHE_RSA:
             return CALG_DH_EPHEM;
@@ -689,3 +527,3 @@
         {
-            FIXME("POLARSSL schannel_get_kx_algid: unknown algorithm %d\n", cipher_suite->key_exchange);
+            FIXME("MBEDTLS schannel_get_kx_algid: unknown algorithm %d\n", cipher_suite->key_exchange);
             return 0;
@@ -697,6 +535,9 @@
 {
-    POLARSSL_SESSION *s = (POLARSSL_SESSION *)session;
-    TRACE("POLARSSL schan_imp_get_session_cipher_block_size %p.\n", session);
+    MBEDTLS_SESSION *s = (MBEDTLS_SESSION *)session;
 
-    return schannel_get_cipher_block_size(ssl_get_ciphersuite_id(ssl_get_ciphersuite(&s->ssl)));
+    unsigned int cipher_block_size = mbedtls_cipher_get_block_size(&s->ssl.transform->cipher_ctx_enc);
+
+    TRACE("MBEDTLS schan_imp_get_session_cipher_block_size %p returning %u.\n", session, cipher_block_size);
+
+    return cipher_block_size;
 }
